#include <bits/stdc++.h>

using namespace std;

#define F first
#define S second
#define mp make_pair
#define pb push_back
#define mt make_tuple

typedef long long ll;
typedef long double ld;

#define next sdakjhfadskf

const int N = 400200;
const int MX = (int)(1e9) + 1000;

int a[N];
int n;

int count(const vector<int> &a, int r) {
    if (r >= MX) return a.size();
    if (r < 0) return 0;
    return max(0, (int)(upper_bound(a.begin(), a.end(), r) - a.begin()));
}

int count(const vector<int> &a, int l, int r) {
    return max(0, count(a, r - 1) - count(a, l - 1));
}

bool solve(int p) {
    int st = (1ll << p);
    int mask = st - 1;
    sort(a, a + n, [&](int a, int b) {
        int ba = a >> p & 1;
        int bb = b >> p & 1;
        if (ba == bb) {
            return (a & mask) < (b & mask);
        }
        return ba < bb;
    });
    long long cnt = 0;
    vector<int> all[2];
    for (int i = 0; i < n; i++) {
        int bi = a[i] >> p & 1;
        cnt += count(all[bi], st - (a[i] & mask), MX);
        cnt += count(all[bi ^ 1], 0, st - (a[i] & mask));
        all[bi].push_back(a[i] & mask);
    }
    return cnt & 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    // cerr << "n = " << n << endl;
    long long ans = 0;
    for (int j = 0; j < 32; j++) {
        if (solve(j)) {
            // cerr << "j = " << j << endl;
            ans += (1ll << j);
        }
    }
    cout << ans << endl;
#ifdef LOCAL
    cerr << "TIME = " << 1.0 * clock() / CLOCKS_PER_SEC << endl;
#endif // LOCAL
    return 0;
}
