#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const int MAXN = 400'000 + 10;

struct Fenw {
    vector<int> tree;

    Fenw(int n) : tree(n + 1) {}

    void add(int pos, int d) {
        for (; pos < tree.size(); pos |= pos + 1) {
            tree[pos] += d;
        }
    }

    int get(int l, int r) {
        if (l > r) return 0;
        return get(r) - get(l - 1);
    }

    int get(int pos) {
        int result = 0;
        for (; pos >= 0; pos = (pos & (pos + 1)) - 1) {
            result += tree[pos];
        }
        return result;
    }
};

ll a[MAXN];

int main() {
#ifdef DARKKEKS
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int n;
    cin >> n;

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    ll result = 0;
    
    for (int b = 0; b < 25; ++b) {
        Fenw v[2] = {Fenw(n), Fenw(n)};

        ll bit = 1ll << b;

        vector<int> pref[2];

        vector<pair<ll, int> > s[2];
        for (int i = 0; i < n; ++i) {
            ll bit_pref = a[i] & (bit - 1);
            pref[(a[i] >> b) & 1].push_back(bit_pref);
        }

        for (int x : {0, 1}) {
            sort(pref[x].begin(), pref[x].end());
            pref[x].erase(unique(pref[x].begin(), pref[x].end()), pref[x].end());
        }

        ll sum = 0;
        for (int i = 0; i < n; ++i) {
            ll bit_pref = a[i] & (bit - 1);
            ll rem = bit - bit_pref;
            if (a[i] & bit) {
                int cnt = 0;

                int p = lower_bound(pref[0].begin(), pref[0].end(), rem) - pref[0].begin();
                cnt += v[0].get(0, p - 1);

                p = lower_bound(pref[1].begin(), pref[1].end(), rem) - pref[1].begin();
                cnt += v[1].get(p, pref[1].size());

                sum += cnt;
            } else {
                int cnt = 0;

                int p = lower_bound(pref[0].begin(), pref[0].end(), rem) - pref[0].begin();
                cnt += v[0].get(p, n);

                p = lower_bound(pref[1].begin(), pref[1].end(), rem) - pref[1].begin();
                cnt += v[1].get(0, p - 1);

                sum += cnt;
            }

            int x = (a[i] >> b) & 1;
            int pos = lower_bound(pref[x].begin(), pref[x].end(), bit_pref) - pref[x].begin();
            v[x].add(pos, 1);
        }
        result += bit * (sum & 1);
    }

    cout << result << "\n";
}
